/* DSTART                                                                    */
/*                                                                           */
/*           maildrop - mail delivery agent with filtering abilities         */
/*                                                                           */
/*  Copyright 1998, Double Precision Inc.                                    */
/*                                                                           */
/*  This program is distributed under the terms of the GNU General Public    */
/*  License. See COPYING for additional information.                         */
/* DEND                                                                      */

#include	"message.h"
#include	"messageinfo.h"

#ifndef	maildrop_h
#define	maildrop_h

static const char maildrop_h_rcsid[]="$Id: maildrop.h 1.1 1998/04/17 00:08:53 mrsam Exp $";

////////////////////////////////////////////////////////////////////////////
//
// Maildrop global variables

#include	"buffer.h"
#include	"globaltimer.h"
#include	"mio.h"
#include	"autoconf.h"

class Maildrop {
public:
	int verbose_level;	// Current verbose level
	int isdelivery;		// Running in delivery mode
static	int sigfpe;		// Floating point exception trapped.
	int includelevel;	// Catch include loops
	int embedded_mode;	// Running in embedded mode

	Message *msgptr, *savemsgptr;	// msgptr is the current message.
					// savemsgptr points to a spare message
					// structure (m1 and m2).
	MessageInfo msginfo;
	Buffer	tempdir;	// Directory for temporary files

	Mio	logfile;	// Log file.
	GlobalTimer global_timer;	// Watchdog timeout.
	Maildrop();

static void cleanup();
static RETSIGTYPE bye(int);
static int trap(int (*)(int, char *[]), int, char *[]);
} ;

extern class Maildrop maildrop;

#endif
