/* DSTART                                                                    */
/*                                                                           */
/*           maildrop - mail delivery agent with filtering abilities         */
/*                                                                           */
/*  Copyright 1998, Double Precision Inc.                                    */
/*                                                                           */
/*  This program is distributed under the terms of the GNU General Public    */
/*  License. See COPYING for additional information.                         */
/* DEND                                                                      */
#ifndef	messageinfo_h
#define	messageinfo_h

static const char messageinfo_h_rcsid[]="$Id: messageinfo.h 1.1 1998/04/17 00:08:53 mrsam Exp $";

#include	<sys/types.h>
#include	"autoconf.h"
#include	"buffer.h"

class	Message;

///////////////////////////////////////////////////////////////////////////
//
//  The MessageInfo class collects information about a message - namely
//  it calculates where the message headers actually start in the Message
//  class.  We ignore blank lines and "From " lines at the beginning of
//  the message
//
///////////////////////////////////////////////////////////////////////////

class	MessageInfo {
public:
	off_t msgoffset;	// Skip leading blank lines and From header
	Buffer fromname;	// Envelope sender

	MessageInfo() : msgoffset(0)	{}
	~MessageInfo()			{}

	void	info(Message &);
	void	filtered() { msgoffset=0; }
} ;
#endif
