/* DSTART                                                                    */
/*                                                                           */
/*           maildrop - mail delivery agent with filtering abilities         */
/*                                                                           */
/*  Copyright 1998, Double Precision Inc.                                    */
/*                                                                           */
/*  This program is distributed under the terms of the GNU General Public    */
/*  License. See COPYING for additional information.                         */
/* DEND                                                                      */
#ifndef	rematchstr_h
#define	rematchstr_h

static const char rematchstr_h_rcsid[]="$Id: rematchstr.h 1.1 1998/04/17 00:08:53 mrsam Exp $";

#include	<sys/types.h>
#include	"autoconf.h"
#include	"rematch.h"

////////////////////////////////////////////////////////////////////////////
//
// ReMatchStr - derive from ReMatch when text matched against a regular
// expression comes from the message body itself.
//
////////////////////////////////////////////////////////////////////////////

class ReMatchStr : public ReMatch {

	const char *str;
	const char *pos;

public:
	ReMatchStr(const char *p) : str(p), pos(p)	{}
	~ReMatchStr();

	int	NextChar();
	int	CurrentChar();
	off_t GetCurrentPos();
	void	SetCurrentPos(off_t);
} ;
#endif
